/* Standard-Definitions */
#include <stdio.h>
#include <math.h>
#include <limits.h>
#include <float.h>
/* Definitions for that program */
#include "useful.h"
#include "complex.h"
#include "combinat.h"

/* Test if a real number is zero */

#define ZERO 1e-8

static int is_zero(REAL num)
 {
  if((num < ZERO) && (num > - ZERO))
    return(TRUE);
  return(FALSE);
 }

/* Compute the binomial coefficient */

void binomial(COMPLEX *n, COMPLEX *m, COMPLEX *result)
 {
  REAL a;
  int nc;
  register int i;

  a = n->re;
  if(! is_zero(n->im))
    display_error("First argument of binomial is not real");

  nc = (int) (m->re+0.5);
  if(! is_zero(m->im))
    display_error("Second argument of binomial is not real");
  if(! is_zero(m->re - (REAL) nc))
    display_error("Second argument of binomial is not an integer");

  result->re = 1;
  result->im = 0;

  for(i=0; i<nc; i++)
   result->re *= ((a - (REAL) i)/((REAL) i+1));
 }
