/* Definitions for matrices that are not sparse */

/* A matrix */

struct full_matrix {
                int rows;
                int columns;
                char bflag;
                COMPLEX **entries;
              };

/* The routines */

extern int is_zero(REAL num);
extern void free_full_matrix(struct full_matrix *m);
extern void alloc_full_matrix(struct full_matrix *m, int rows, int columns, char bflag);
extern void show_full_matrix(struct full_matrix *m);
extern void jacobi_diagonalize(struct full_matrix *m, struct full_matrix *v, REAL accuracy);
extern void full_adjoint(struct full_matrix *s, struct full_matrix *d);
extern void copy_matrix_to_full(struct matrix *s, struct full_matrix *d);
extern void tridiag_ql_implicit(struct matrix *inp, struct full_matrix *bchg, struct vector *res);
extern void householder_diagonalize(struct full_matrix *m, struct vector *res);
