/* Standard-Definitions */
#include <stdio.h>
/* Definitions for that program */
#include "useful.h"
#include "text.h"
#include "help.h"

#include "date.h"

static char help_path[200] = {0};

/* Set the path for help */

void set_helppath(char *path)
 {
   register int i;

   i=0;
   while(help_path[i] = *path++)
          i++;
 }

/* Display help */

void help(UBYTE *subtopic)
 {
   FILE *fpi;
   char inputstr[512];
   register int i;
   int flag;
   char *flag1;
   int current_ofs, output_flag;

   sprintf(inputstr, "%s%s", help_path, HELPNAME);
   fpi=fopen(inputstr, "r");
   if(fpi)
    {
      if(! subtopic[0])
       {
        printf("Pocket-calculator\n%s\nDate: %s\n\n", COPYRIGHT, DATE);
        while(fgets(inputstr, 511, fpi))
         {
           for(i=0; inputstr[i]; i++)
             if(inputstr[i] == '\n')
                inputstr[i] = 0;
           if(! strncmp(inputstr, "---", 3))
              goto display_topics;
           puts(inputstr);
         }
       }
      else
       {
         flag = FALSE;
         while(fgets(inputstr, 511, fpi))
          {
            for(i=0; inputstr[i]; i++)
             if(inputstr[i] == '\n')
                inputstr[i] = 0;
            if(flag)
             {
              for(i=0; inputstr[i]; i++)
               if(inputstr[i] <= ' ')
                 if(compare(subtopic, inputstr+i+1))
                   goto read_subtopic;
             }
            if(! strncmp(inputstr, "---", 3))
              flag = TRUE;
            else
              flag = FALSE;
          }
         display_error_text("No help available for '%s'", subtopic);
         return;
       }
      goto error;
    }
   else
    {
     display_error_text("Helpfile '%s' not found", HELPNAME);
     return;
    }

 display_topics:		/* Subtopic aus dem File extrahieren */
   printf("\nAdditional help is available for the following functions:\n");
   flag = TRUE;
   current_ofs=0;
   output_flag = FALSE;
   while(flag1 = fgets(inputstr, 511, fpi))
    {
     for(i=0; inputstr[i]; i++)
       if(inputstr[i] == '\n')
           inputstr[i] = 0;
     if(flag)
      {
         if(strncmp("function", inputstr, 8))
            goto display_topics1;
         if(output_flag)
          {
            printf(", ");
            current_ofs += 2;
          }
         else
          {
           printf("    ");
           current_ofs=4;
           output_flag = TRUE;
          }
         if(current_ofs + strlen(inputstr+9) > 75)
          {
           printf("\n    ");
           current_ofs=4;
          }
         printf(inputstr+9);
         current_ofs += strlen(inputstr+9);
      }
     if(! strncmp(inputstr, "---", 3))
        flag = TRUE;
     else
        flag = FALSE;
    }
   flag = FALSE;
 display_topics1:
   printf("\n\nand the following directives:\n");
   current_ofs=0;
   output_flag = FALSE;
   while(flag1)
    {
     for(i=0; inputstr[i]; i++)
       if(inputstr[i] == '\n')
           inputstr[i] = 0;
     if(flag)
      {
         if(strncmp("command", inputstr, 7))
            goto display_topics2;
         if(output_flag)
          {
            printf(", ");
            current_ofs += 2;
          }
         else
          {
           printf("    ");
           current_ofs=4;
           output_flag = TRUE;
          }
         if(current_ofs + strlen(inputstr+8) > 75)
          {
           printf("\n    ");
           current_ofs=4;
          }
         printf(inputstr+8);
         current_ofs += strlen(inputstr+8);
      }
     if(! strncmp(inputstr, "---", 3))
        flag = TRUE;
     else
        flag = FALSE;
     flag1 = fgets(inputstr, 511, fpi);
    }
   flag = FALSE;
 display_topics2:
   printf("\n\nas well as the following functions on vectors and matrices:\n");
   current_ofs=0;
   output_flag = FALSE;
   while(flag1)
    {
     for(i=0; inputstr[i]; i++)
       if(inputstr[i] == '\n')
           inputstr[i] = 0;
     if(flag)
      {
         if(strncmp("vmfunc", inputstr, 6))
            goto display_topics3;
         if(output_flag)
          {
            printf(", ");
            current_ofs += 2;
          }
         else
          {
           printf("    ");
           current_ofs=4;
           output_flag = TRUE;
          }
         if(current_ofs + strlen(inputstr+7) > 75)
          {
           printf("\n    ");
           current_ofs=4;
          }
         printf(inputstr+7);
         current_ofs += strlen(inputstr+7);
      }
     if(! strncmp(inputstr, "---", 3))
        flag = TRUE;
     else
        flag = FALSE;
     flag1 = fgets(inputstr, 511, fpi);
    }
 display_topics3:
   printf("\n\nEnter expression to be evaluated\n");
   printf("or 'bye' (or 'quit') to quit.\n");
   return;

 read_subtopic:			/* Subtopic anzeigen */
   if(! strncmp(inputstr, "function", 8))
     printf("'%s' is a complex function\n\n", inputstr+1+i);
   if(! strncmp(inputstr, "command", 7))
     printf("'%s' is a command (or statement)\n\n", inputstr+1+i);
   if(! strncmp(inputstr, "vmfunc", 6))
     printf("'%s' is a function on vectors and/or matrices\n\n", inputstr+1+i);
   while(fgets(inputstr, 511, fpi))
    {
     for(i=0; inputstr[i]; i++)
       if(inputstr[i] == '\n')
          inputstr[i] = 0;
     if(! strncmp(inputstr, "---", 3))
       return;
     puts(inputstr);
    }

 error:
   display_error("Helpfile corrupt");
 }

void apropos(UBYTE *string)
 {
   FILE *fpi;
   char inputstr[512], funstr[512];
   register int i, j;
   int gflag, flag, flag1;

   sprintf(inputstr, "%s%s", help_path, HELPNAME);
   fpi=fopen(inputstr, "r");
   if(fpi)
    {
      gflag = flag1 = flag = FALSE;
      funstr[0] = 0;
      while(fgets(inputstr, 511, fpi))
       {
        for(i=0; inputstr[i]; i++)
         if(inputstr[i] == '\n')
            inputstr[i] = 0;
        if(flag)
         {
          flag1 = flag = FALSE;
          for(i=0; funstr[i] = inputstr[i]; i++)
               ;
         }
        else
         {
          for(i=0; inputstr[i]; i++)
           {
            for(j=0; string[j] &&
              (conv_to_lower(string[j]) == conv_to_lower(inputstr[i+j])); j++)
                       ;
            if(! string[j])
              flag1 = TRUE;
           }
         }
        if(! strncmp(inputstr, "---", 3))
         {
          if(flag1 && funstr[0])
           {
            if(! gflag)
              printf("The keyword '%s' appears in help on:\n", string);
            else
              printf(", ");
            for(i=0; funstr[i] > ' '; i++)
                   ;
            printf("%s", funstr+i+1);
            gflag = TRUE;
           }
          flag = TRUE;
          flag1 = FALSE;
         }
       }
      fclose(fpi);
      if(! gflag)
        printf("Sorry, nothing appropriate for '%s'.\n", string);
      else
        printf("\nFor more details consult help on them.\n");
    }
   else
    {
     display_error_text("Helpfile '%s' not found", HELPNAME);
     return;
    }
 }
